﻿using System;
using System.Collections.ObjectModel;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;
using System.Collections.Generic;

namespace DisplayASimpleMapForMvc.Controllers
{
    public class IndexController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        [MapActionFilter]
        public void GetPoints(Map map, GeoCollection<object> args)
        {
            string olExtentStr = args[0].ToString();
            string[] olExtentAarry = olExtentStr.Split(',');
            RectangleShape currentExtent = new RectangleShape(double.Parse(olExtentAarry[0]), double.Parse(olExtentAarry[3]), double.Parse(olExtentAarry[2]), double.Parse(olExtentAarry[1]));

            InMemoryFeatureLayer pointLayer = (map.CustomOverlays["PointOverlay"] as LayerOverlay).Layers[0] as InMemoryFeatureLayer;

            lock (pointLayer)
            {
                pointLayer.Open();
                Random random = new Random();
                for (int i = 0; i < 10; i++)
                {
                    PointShape pointShape = new PointShape(currentExtent.LowerLeftPoint.X + random.NextDouble() * currentExtent.Width, currentExtent.LowerLeftPoint.Y + random.NextDouble() * currentExtent.Height);
                    pointLayer.InternalFeatures.Add(new Feature(pointShape));
                }
            }
        }
    }
}
